searchData={"items":[{"type":"extras","title":"Bulma","doc":"# Bulma\n\nYou can use this package to install Bulma in your Phoenix project without needing to rely on Node or NPM.\nIt works by leveraging the [DartSass](https://github.com/cargosense/dart_sass) package.","ref":"readme.html"},{"type":"extras","title":"Installing DartSass - Bulma","doc":"DartSass is an Elixir library that works similar to Esbuild and does actual Sass processing.\n\n#### Install DartSass in `mix.exs`\n\n[https://github.com/CargoSense/dart_sass](`dart_sass`) Github repo.\n\nAdd the following line to your `deps()` section:\n\n```elixir\n{:dart_sass, \"~> 0.7\", runtime: Mix.env() == :dev}\n```\n\nThen configure which version of dart-sass to use by adding this to your `config/config.exs` file.\n\nYou will probably need to check on [NPM](https://www.npmjs.com/package/sass) to get the latest version number.\n\n```elixir\nconfig :dart_sass,\nversion: \"1.79.3\",\ndefault: [\nargs: ~w(css:../priv/static/assets),\ncd: Path.expand(\"../assets\", __DIR__)\n]\n```\n\nRun `mix deps.get` then install Sass:\n\n```sh\nmix sass.install\n```","ref":"readme.html#installing-dartsass"},{"type":"extras","title":"Rename assets/css/app.css - Bulma","doc":"Rename the existing `assets/css/app.css` to `assets/css/app.scss`.","ref":"readme.html#rename-assets-css-app-css"},{"type":"extras","title":"Update app.js in assets/js/ - Bulma","doc":"Comment out or delete this line:\n\n```javascript\n// import \"../css/app.css\";\n```\n\nFor development, enable watch mode by changing your watchers configuration for `MyApp.Endpoint` in `config/dev.exs`.\n\n```elixir\nwatchers: [\n  # Start the esbuild watcher by calling Esbuild.install_and_run(:default, args)\n  esbuild: {Esbuild, :install_and_run, [:default, ~w(--sourcemap=inline --watch)]},\n  sass: {\n    DartSass,\n    :install_and_run,\n    [:default, ~w(--embed-source-map --source-map-urls=absolute --watch)]\n  }\n]\n```\n\nFinally, back in your mix.exs, make sure you have an assets.deploy alias for deployments, which will also use the --style=compressed option:\n\n```elixir\n\"assets.deploy\": [\n  \"esbuild default --minify\",\n  \"sass default --no-source-map --style=compressed\",\n  \"phx.digest\"\n]\n```","ref":"readme.html#update-app-js-in-assets-js"},{"type":"extras","title":"Installing Bulma - Bulma","doc":"There are effectively three different ways to install Bulma.","ref":"readme.html#installing-bulma"},{"type":"extras","title":"Method 1: Using a CDN - Bulma","doc":"The first way to install Bulma is to just include the `bulma.min.css` file from a CDN like [JSDeliver](https://www.jsdelivr.com/package/npm/bulma). With this approach, you would not be able to customize Bulma at all.","ref":"readme.html#method-1-using-a-cdn"},{"type":"extras","title":"Method 2: Using Node and npm - Bulma","doc":"The second way is to install `node` and `npm`, create a `package.json` file, add `bulma` to it, then tell `dart-sass` where the Sass files were installed. However, this makes our app depend on `node` again.","ref":"readme.html#method-2-using-node-and-npm"},{"type":"extras","title":"Method 3: Using Hex Package - Bulma","doc":"The third way is to install the [Bulma Hex package](https://github.com/kevinlang/bulma-elixir). This approach includes all of the Bulma Sass files in a convenient package that can easily be added to your Mix project. To do this:\n\n* Go to your `mix.exs` file and add it:\n\n```elixir\n{:bulma, \"1.0.2\"}\n```\n\n* Update your `dart-sass` config to include it as a load path:\n\n```elixir\nconfig :dart_sass,\n  version: \"1.79.3\",\n  default: [\n    args: ~w(--load-path=../deps/bulma css:../priv/static/assets),\n    cd: Path.expand(\"../assets\", __DIR__)\n  ]\n```\n\n* Import Bulma into your root style sheet, `assets/css/app.scss`:\n\n```scss\n@import \"bulma\";\n```","ref":"readme.html#method-3-using-hex-package"},{"type":"extras","title":"Using Bulma and CSS Cleanup - Bulma","doc":"Now that we have Bulma installed, let's do some minimal changes to the generated app. First, get rid of the `assets/css/phoenix.css` file.\n\nThen replace the content of the `assets/css/app.scss` file with:\n\n```scss\n// override bulma variables before import to customize\n$phoenix-orange: #f05423;\n$primary: $phoenix-orange;\n\n@import \"bulma\";\n\n// add our own styles after the Bulma import\n```\n\nHere we are overriding the `$primary` variable outlined in the [Bulma docs](https://bulma.io/documentation/customize/variables/) to our `$phoenix-orange` color.","ref":"readme.html#using-bulma-and-css-cleanup"},{"type":"extras","title":"Updating HTML Files - Bulma","doc":"Let's update some of our HTML files so we can show Bulma in action. First, remove the header in `root.html.heex`.\n\nThen let's make a nice big Bulma hero section on our main `index.html` page:\n\n```html\n \n   \n     \n       Phoenix \n       With Bulma! \n     \n   \n \n```\n\nThe version of this package exactly matches the version of Bulma that it contains. As of now, it has version `1.0.2`.","ref":"readme.html#updating-html-files"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}